// Generated by psc version 0.8.0.0
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Argonaut_Printer = require("../Data.Argonaut.Printer");
var Data_Argonaut_Parser = require("../Data.Argonaut.Parser");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Argonaut_Encode = require("../Data.Argonaut.Encode");
var Data_Array = require("../Data.Array");
var Data_Array_Unsafe = require("../Data.Array.Unsafe");
var Data_Either = require("../Data.Either");
var Data_Foldable = require("../Data.Foldable");
var Data_Traversable = require("../Data.Traversable");
var Data_StrMap = require("../Data.StrMap");
var Data_StrMap_ST = require("../Data.StrMap.ST");
var Data_Maybe = require("../Data.Maybe");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Exception = require("../Control.Monad.Eff.Exception");
var Control_Monad_ST = require("../Control.Monad.ST");
var Control_Apply = require("../Control.Apply");
var Control_Monad = require("../Control.Monad");
var Node_Process = require("../Node.Process");
var Node_ChildProcess = require("../Node.ChildProcess");
var Node_Stream = require("../Node.Stream");
var Node_Buffer = require("../Node.Buffer");
var Node_Encoding = require("../Node.Encoding");
var Node_FS = require("../Node.FS");
var Node_FS_Sync = require("../Node.FS.Sync");
var Node_Path = require("../Node.Path");
var Psa = require("../Psa");
var Psa_Printer_Default = require("../Psa.Printer.Default");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var Data_Posix_Signal = require("../Data.Posix.Signal");
var usage = "psa - Error/Warning reporting frontend for psc \n\nUsage: psa [--censor-lib] [--censor-src]\n           [--censor-codes=CODES] [--filter-codes=CODES]\n           [--no-colors] [--no-source]\n           [--is-lib=DIR] [--psc=PSC] [--stash]\n           PSC_OPTIONS\n\nAvailable options:\n  -v,--version           Show the version number\n  -h,--help              Show this help text\n  --verbose-stats        Show counts for each warning type\n  --censor-warnings      Censor all warnings\n  --censor-lib           Censor warnings from library sources\n  --censor-src           Censor warnings from project sources\n  --censor-codes=CODES   Censor specific error codes\n  --filter-codes=CODES   Only show specific error codes\n  --no-colors            Disable ANSI colors\n  --no-source            Disable original source code printing\n  --strict               Promotes src warnings to errors\n  --stash                Enable persistent warnings (defaults to .psa-stash)\n  --stash=FILE           Enable persistent warnings using a specific stash file\n  --is-lib=DIR           Distinguishing library path (defaults to 'bower_components')\n  --psc=PSC              Name of psc executable (defaults to 'psc')\n\n  CODES                  Comma-separated list of psc error codes\n  PSC_OPTIONS            Any extra options are passed to psc\n";
var parseOptions = function (opts) {
    return function (args) {
        var isPrefix = function (s) {
            return function (str) {
                var $22 = Data_String.indexOf(s)(str);
                if ($22 instanceof Data_Maybe.Just && $22.value0 === 0) {
                    return true;
                };
                return false;
            };
        };
        var parse = function (p) {
            return function (arg) {
                if (Prelude["=="](Prelude.eqString)(arg)("--version") || Prelude["=="](Prelude.eqString)(arg)("-v")) {
                    return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log($foreign.version))(Node_Process.exit(0));
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--help") || Prelude["=="](Prelude.eqString)(arg)("-h")) {
                    return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log(usage))(Node_Process.exit(0));
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--stash")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $26 = {};
                        for (var $27 in p) {
                            if (p.hasOwnProperty($27)) {
                                $26[$27] = p[$27];
                            };
                        };
                        $26.stash = true;
                        return $26;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--no-source")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $28 = {};
                        for (var $29 in p) {
                            if (p.hasOwnProperty($29)) {
                                $28[$29] = p[$29];
                            };
                        };
                        $28.showSource = false;
                        return $28;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--no-colors") || Prelude["=="](Prelude.eqString)(arg)("--monochrome")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $32 = {};
                        for (var $33 in p) {
                            if (p.hasOwnProperty($33)) {
                                $32[$33] = p[$33];
                            };
                        };
                        $32.opts = (function () {
                            var $30 = {};
                            for (var $31 in p.opts) {
                                if (p.opts.hasOwnProperty($31)) {
                                    $30[$31] = p.opts[$31];
                                };
                            };
                            $30.ansi = false;
                            return $30;
                        })();
                        return $32;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--verbose-stats")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $36 = {};
                        for (var $37 in p) {
                            if (p.hasOwnProperty($37)) {
                                $36[$37] = p[$37];
                            };
                        };
                        $36.opts = (function () {
                            var $34 = {};
                            for (var $35 in p.opts) {
                                if (p.opts.hasOwnProperty($35)) {
                                    $34[$35] = p.opts[$35];
                                };
                            };
                            $34.verboseStats = true;
                            return $34;
                        })();
                        return $36;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--strict")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $40 = {};
                        for (var $41 in p) {
                            if (p.hasOwnProperty($41)) {
                                $40[$41] = p[$41];
                            };
                        };
                        $40.opts = (function () {
                            var $38 = {};
                            for (var $39 in p.opts) {
                                if (p.opts.hasOwnProperty($39)) {
                                    $38[$39] = p.opts[$39];
                                };
                            };
                            $38.strict = true;
                            return $38;
                        })();
                        return $40;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--censor-warnings")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $44 = {};
                        for (var $45 in p) {
                            if (p.hasOwnProperty($45)) {
                                $44[$45] = p[$45];
                            };
                        };
                        $44.opts = (function () {
                            var $42 = {};
                            for (var $43 in p.opts) {
                                if (p.opts.hasOwnProperty($43)) {
                                    $42[$43] = p.opts[$43];
                                };
                            };
                            $42.censorWarnings = true;
                            return $42;
                        })();
                        return $44;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--censor-lib")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $48 = {};
                        for (var $49 in p) {
                            if (p.hasOwnProperty($49)) {
                                $48[$49] = p[$49];
                            };
                        };
                        $48.opts = (function () {
                            var $46 = {};
                            for (var $47 in p.opts) {
                                if (p.opts.hasOwnProperty($47)) {
                                    $46[$47] = p.opts[$47];
                                };
                            };
                            $46.censorLib = true;
                            return $46;
                        })();
                        return $48;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--censor-lib")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $52 = {};
                        for (var $53 in p) {
                            if (p.hasOwnProperty($53)) {
                                $52[$53] = p[$53];
                            };
                        };
                        $52.opts = (function () {
                            var $50 = {};
                            for (var $51 in p.opts) {
                                if (p.opts.hasOwnProperty($51)) {
                                    $50[$51] = p.opts[$51];
                                };
                            };
                            $50.censorLib = true;
                            return $50;
                        })();
                        return $52;
                    })());
                };
                if (Prelude["=="](Prelude.eqString)(arg)("--censor-src")) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $56 = {};
                        for (var $57 in p) {
                            if (p.hasOwnProperty($57)) {
                                $56[$57] = p[$57];
                            };
                        };
                        $56.opts = (function () {
                            var $54 = {};
                            for (var $55 in p.opts) {
                                if (p.opts.hasOwnProperty($55)) {
                                    $54[$55] = p.opts[$55];
                                };
                            };
                            $54.censorSrc = true;
                            return $54;
                        })();
                        return $56;
                    })());
                };
                if (isPrefix("--censor-codes=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $60 = {};
                        for (var $61 in p) {
                            if (p.hasOwnProperty($61)) {
                                $60[$61] = p[$61];
                            };
                        };
                        $60.opts = (function () {
                            var $58 = {};
                            for (var $59 in p.opts) {
                                if (p.opts.hasOwnProperty($59)) {
                                    $58[$59] = p.opts[$59];
                                };
                            };
                            $58.censorCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.censorCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $58;
                        })();
                        return $60;
                    })());
                };
                if (isPrefix("--filter-codes=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $64 = {};
                        for (var $65 in p) {
                            if (p.hasOwnProperty($65)) {
                                $64[$65] = p[$65];
                            };
                        };
                        $64.opts = (function () {
                            var $62 = {};
                            for (var $63 in p.opts) {
                                if (p.opts.hasOwnProperty($63)) {
                                    $62[$63] = p.opts[$63];
                                };
                            };
                            $62.filterCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.filterCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $62;
                        })();
                        return $64;
                    })());
                };
                if (isPrefix("--is-lib=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $68 = {};
                        for (var $69 in p) {
                            if (p.hasOwnProperty($69)) {
                                $68[$69] = p[$69];
                            };
                        };
                        $68.opts = (function () {
                            var $66 = {};
                            for (var $67 in p.opts) {
                                if (p.opts.hasOwnProperty($67)) {
                                    $66[$67] = p.opts[$67];
                                };
                            };
                            $66.libDirs = Data_Array.snoc(p.opts.libDirs)(Data_String.drop(9)(arg));
                            return $66;
                        })();
                        return $68;
                    })());
                };
                if (isPrefix("--psc=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $70 = {};
                        for (var $71 in p) {
                            if (p.hasOwnProperty($71)) {
                                $70[$71] = p[$71];
                            };
                        };
                        $70.psc = Data_String.drop(6)(arg);
                        return $70;
                    })());
                };
                if (isPrefix("--stash=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $72 = {};
                        for (var $73 in p) {
                            if (p.hasOwnProperty($73)) {
                                $72[$73] = p[$73];
                            };
                        };
                        $72.stash = true;
                        $72.stashFile = Data_String.drop(8)(arg);
                        return $72;
                    })());
                };
                if (Prelude.otherwise) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $74 = {};
                        for (var $75 in p) {
                            if (p.hasOwnProperty($75)) {
                                $74[$75] = p[$75];
                            };
                        };
                        $74.extra = Data_Array.snoc(p.extra)(arg);
                        return $74;
                    })());
                };
                throw new Error("Failed pattern match at Main line 94, column 1 - line 99, column 1: " + [ p.constructor.name, arg.constructor.name ]);
            };
        };
        var defaultLibDir = function (x) {
            if (Data_Array.length(x.opts.libDirs) === 0) {
                var $79 = {};
                for (var $80 in x) {
                    if (x.hasOwnProperty($80)) {
                        $79[$80] = x[$80];
                    };
                };
                $79.opts = (function () {
                    var $77 = {};
                    for (var $78 in x.opts) {
                        if (x.opts.hasOwnProperty($78)) {
                            $77[$78] = x.opts[$78];
                        };
                    };
                    $77.libDirs = [ "bower_components" ];
                    return $77;
                })();
                return $79;
            };
            if (Prelude.otherwise) {
                return x;
            };
            throw new Error("Failed pattern match at Main line 94, column 1 - line 99, column 1: " + [ x.constructor.name ]);
        };
        return Prelude["<$>"](Control_Monad_Eff.functorEff)(defaultLibDir)(Data_Array.foldM(Control_Monad_Eff.monadEff)(parse)({
            extra: [  ], 
            psc: "psc", 
            showSource: true, 
            stash: false, 
            stashFile: ".psa-stash", 
            opts: opts
        })(args));
    };
};
var defaultOptions = {
    ansi: true, 
    censorWarnings: false, 
    censorLib: false, 
    censorSrc: false, 
    censorCodes: Data_Set.empty, 
    filterCodes: Data_Set.empty, 
    verboseStats: false, 
    libDirs: [  ], 
    strict: false, 
    cwd: ""
};
var main = (function () {
    
    /**
     *  TODO: Handle exceptions
     */
    var stdio = [ new Data_Maybe.Just(Node_ChildProcess.Pipe.value), Node_ChildProcess.inherit[1], new Data_Maybe.Just(Node_ChildProcess.Pipe.value) ];
    var mergeWarnings = function (filenames) {
        return function (old) {
            return function ($$new) {
                return function __do() {
                    var v = Data_StrMap_ST["new"]();
                    var v1 = Prelude.flip(Data_Array.filterM(Control_Monad_Eff.monadEff))(old)(function (x) {
                        if (x.filename instanceof Data_Maybe.Nothing) {
                            return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                        };
                        if (x.filename instanceof Data_Maybe.Just) {
                            var $83 = Data_Set.member(Prelude.ordString)(x.filename.value0)(filenames);
                            if ($83) {
                                return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                            };
                            if (!$83) {
                                return function __do() {
                                    var v1 = Data_StrMap_ST.peek(v)(x.filename.value0)();
                                    return (function () {
                                        if (v1 instanceof Data_Maybe.Just) {
                                            return Prelude.pure(Control_Monad_Eff.applicativeEff)(v1.value0);
                                        };
                                        if (v1 instanceof Data_Maybe.Nothing) {
                                            return function __do() {
                                                var v2 = Node_FS_Sync.exists(x.filename.value0)();
                                                Data_StrMap_ST.poke(v)(x.filename.value0)(v2)();
                                                return v2;
                                            };
                                        };
                                        throw new Error("Failed pattern match: " + [ v1.constructor.name ]);
                                    })()();
                                };
                            };
                            throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ $83.constructor.name ]);
                        };
                        throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ x.filename.constructor.name ]);
                    })();
                    return Prelude["<>"](Prelude.semigroupArray)(v1)($$new);
                };
            };
        };
    };
    var loadNothing = function (v) {
        return function (v1) {
            return Prelude.pure(Control_Monad_Eff.applicativeEff)(Data_Maybe.Nothing.value);
        };
    };
    var loadLines = function (files) {
        return function (filename) {
            return function (pos) {
                return function __do() {
                    var v = (function __do() {
                        var cache = Data_StrMap_ST.peek(files)(filename)();
                        if (cache instanceof Data_Maybe.Just) {
                            return cache.value0;
                        };
                        if (cache instanceof Data_Maybe.Nothing) {
                            var v = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(filename))();
                            Data_StrMap_ST.poke(files)(filename)(v)();
                            return v;
                        };
                        throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ cache.constructor.name ]);
                    })();
                    return (function () {
                        var source = Data_Array.slice(pos.startLine - 1)(pos.endLine)(v);
                        return Prelude.pure(Control_Monad_Eff.applicativeEff)(new Data_Maybe.Just(source));
                    })()();
                };
            };
        };
    };
    var insertFilenames = Data_Foldable.foldr(Data_Foldable.foldableArray)(function (x) {
        return function (s) {
            return Data_Maybe.maybe(s)(Prelude.flip(Data_Set.insert(Prelude.ordString))(s))(x.filename);
        };
    });
    var encodeStash = function (s) {
        return Data_Argonaut_Encode.encodeJson(Data_Argonaut_Encode.encodeJsonArray(Data_Argonaut_Encode.encodeJsonJson))(Prelude["<$>"](Prelude.functorArray)(Psa_Types.encodePsaError)(s));
    };
    var writeStashFile = function (stashFile) {
        return function (warnings) {
            var file = Data_Argonaut_Printer.printJson(Data_Argonaut_Printer.printerString)(encodeStash(warnings));
            return Node_FS_Sync.writeTextFile(Node_Encoding.UTF8.value)(stashFile)(file);
        };
    };
    var decodeStash = function (s) {
        return Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(s))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeArray(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson)))))(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(Psa_Types.parsePsaError));
    };
    var readStashFile = function (stashFile) {
        return function __do() {
            var v = Node_FS_Sync.exists(stashFile)();
            return (function () {
                if (v) {
                    return function __do() {
                        var v1 = Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(stashFile)();
                        return decodeStash(v1);
                    };
                };
                if (!v) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)(new Data_Either.Left(stashFile + " does not exist"));
                };
                throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ v.constructor.name ]);
            })()();
        };
    };
    return Prelude["void"](Control_Monad_Eff.functorEff)(function __do() {
        var v = Node_Process.cwd();
        var v1 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process.argv)();
        var v2 = parseOptions((function () {
            var $99 = {};
            for (var $100 in defaultOptions) {
                if (defaultOptions.hasOwnProperty($100)) {
                    $99[$100] = defaultOptions[$100];
                };
            };
            $99.cwd = v;
            return $99;
        })())(v1)();
        return (function () {
            var opts$prime = (function () {
                var $102 = {};
                for (var $103 in v2.opts) {
                    if (v2.opts.hasOwnProperty($103)) {
                        $102[$103] = v2.opts[$103];
                    };
                };
                $102.libDirs = Prelude["<$>"](Prelude.functorArray)(function ($130) {
                    return (function (v3) {
                        return v3 + Node_Path.sep;
                    })(Node_Path.resolve([ v ])($130));
                })(v2.opts.libDirs);
                return $102;
            })();
            return function __do() {
                var v3 = (function () {
                    if (v2.stash) {
                        return Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Either.either(Prelude["const"]([  ]))(Prelude.id(Prelude.categoryFn)))(readStashFile(v2.stashFile));
                    };
                    if (!v2.stash) {
                        return Prelude.pure(Control_Monad_Eff.applicativeEff)([  ]);
                    };
                    throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ v2.stash.constructor.name ]);
                })()();
                var v4 = Node_ChildProcess.spawn(v2.psc)(Data_Array.cons("--json-errors")(v2.extra))((function () {
                    var $106 = {};
                    for (var $107 in Node_ChildProcess.defaultSpawnOptions) {
                        if (Node_ChildProcess.defaultSpawnOptions.hasOwnProperty($107)) {
                            $106[$107] = Node_ChildProcess.defaultSpawnOptions[$107];
                        };
                    };
                    $106.stdio = stdio;
                    return $106;
                })())();
                var v5 = Control_Monad_ST.newSTRef("")();
                Node_Stream.onDataString(Node_ChildProcess.stderr(v4))(Node_Encoding.UTF8.value)(function (chunk) {
                    return Prelude["void"](Control_Monad_Eff.functorEff)(Control_Monad_ST.modifySTRef(v5)(function (v6) {
                        return v6 + chunk;
                    }));
                })();
                return Node_ChildProcess.onExit(v4)(function (status) {
                    if (status instanceof Node_ChildProcess.Normally) {
                        return function __do() {
                            var v6 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Control_Monad_ST.readSTRef(v5))();
                            Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(Data_Foldable.foldableArray)(v6)(function (err) {
                                var $112 = Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(err))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson))))(Psa_Types.parsePsaResult);
                                if ($112 instanceof Data_Either.Left) {
                                    return Control_Monad_Eff_Console.error(err);
                                };
                                if ($112 instanceof Data_Either.Right) {
                                    return function __do() {
                                        var v7 = Data_StrMap_ST["new"]();
                                        return (function () {
                                            var loadLinesImpl = (function () {
                                                if (v2.showSource) {
                                                    return loadLines(v7);
                                                };
                                                if (!v2.showSource) {
                                                    return loadNothing;
                                                };
                                                throw new Error("Failed pattern match at Main line 219, column 19 - line 220, column 15: " + [ v2.showSource.constructor.name ]);
                                            })();
                                            var filenames = insertFilenames(insertFilenames(Data_Set.empty)($112.value0.errors))($112.value0.warnings);
                                            return function __do() {
                                                var v8 = mergeWarnings(filenames)(v3)($112.value0.warnings)();
                                                var v9 = Psa_Output.output(Control_Monad_Eff.monadEff)(loadLinesImpl)(opts$prime)((function () {
                                                    var $117 = {};
                                                    for (var $118 in $112.value0) {
                                                        if ($112.value0.hasOwnProperty($118)) {
                                                            $117[$118] = $112.value0[$118];
                                                        };
                                                    };
                                                    $117.warnings = v8;
                                                    return $117;
                                                })())();
                                                Control_Monad.when(Control_Monad_Eff.monadEff)(v2.stash)(writeStashFile(v2.stashFile)(v8))();
                                                Psa_Printer_Default.print(opts$prime)(v9)();
                                                var $120 = Data_StrMap.isEmpty(v9.stats.allErrors);
                                                if ($120) {
                                                    return Node_Process.exit(0)();
                                                };
                                                if (!$120) {
                                                    return Node_Process.exit(1)();
                                                };
                                                throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ $120.constructor.name ]);
                                            };
                                        })()();
                                    };
                                };
                                throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ $112.constructor.name ]);
                            })();
                            return Node_Process.exit(status.value0)();
                        };
                    };
                    if (status instanceof Node_ChildProcess.BySignal) {
                        return function __do() {
                            Control_Monad_Eff_Console.error(Prelude.show(Data_Posix_Signal.showSignal)(status.value0))();
                            return Node_Process.exit(1)();
                        };
                    };
                    throw new Error("Failed pattern match at Main line 183, column 1 - line 184, column 1: " + [ status.constructor.name ]);
                })();
            };
        })()();
    });
})();
module.exports = {
    main: main, 
    parseOptions: parseOptions, 
    defaultOptions: defaultOptions, 
    usage: usage, 
    version: $foreign.version
};
